// PCI1389S02DllTestDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "afxwin.h"
#include "string.h"
#include "conio.h"
#include "PCI1389S02DllTest.h"
#include "PCI1389S02DllTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPCI1389S02DllTestDlg Dialogfeld

CPCI1389S02DllTestDlg::CPCI1389S02DllTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPCI1389S02DllTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPCI1389S02DllTestDlg)
		// HINWEIS: Der Klassenassistent fgt hier Member-Initialisierung ein
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPCI1389S02DllTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPCI1389S02DllTestDlg)
	DDX_Control(pDX, IDC_REFWAIT, m_RefWait);
	DDX_Control(pDX, IDC_REFTIMEOUT, m_RefTimeOut);
	DDX_Control(pDX, IDC_REFSTOP, m_RefStop);
	DDX_Control(pDX, IDC_REFRUN, m_RefRun);
	DDX_Control(pDX, IDC_REFINERR, m_RefInErr);
	DDX_Control(pDX, IDC_DOA4, m_DoutA4);
	DDX_Control(pDX, IDC_DOA3, m_DoutA3);
	DDX_Control(pDX, IDC_DOA2, m_DoutA2);
	DDX_Control(pDX, IDC_DOA1, m_DoutA1);
	DDX_Control(pDX, IDC_DINE4, m_DinE4);
	DDX_Control(pDX, IDC_DINE3, m_DinE3);
	DDX_Control(pDX, IDC_DINE2, m_DinE2);
	DDX_Control(pDX, IDC_DINE1, m_DinE1);
	DDX_Control(pDX, IDC_CNT2WAIT, m_Cnt2Wait);
	DDX_Control(pDX, IDC_CNT2VALUE, m_Cnt2Value);
	DDX_Control(pDX, IDC_CNT2TIMEOUT, m_Cnt2TimeOut);
	DDX_Control(pDX, IDC_CNT2STOP, m_Cnt2Stop);
	DDX_Control(pDX, IDC_CNT2RUN, m_Cnt2Run);
	DDX_Control(pDX, IDC_CNT2OV, m_Cnt2OV);
	DDX_Control(pDX, IDC_CNT2INERR, m_Cnt2InErr);
	DDX_Control(pDX, IDC_CNT2COUNT, m_Cnt2Count);
	DDX_Control(pDX, IDC_CNT1WAIT, m_Cnt1Wait);
	DDX_Control(pDX, IDC_CNT1VALUE, m_Cnt1Value);
	DDX_Control(pDX, IDC_CNT1TIMEOUT, m_Cnt1TimeOut);
	DDX_Control(pDX, IDC_CNT1STOP, m_Cnt1Stop);
	DDX_Control(pDX, IDC_CNT1RUN, m_Cnt1Run);
	DDX_Control(pDX, IDC_CNT1OV, m_Cnt1OV);
	DDX_Control(pDX, IDC_CNT1INERR, m_Cnt1InErr);
	DDX_Control(pDX, IDC_CNT1COUNT, m_Cnt1Count);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPCI1389S02DllTestDlg, CDialog)
	//{{AFX_MSG_MAP(CPCI1389S02DllTestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_DOA1, OnDoa1)
	ON_BN_CLICKED(IDC_DOA2, OnDoa2)
	ON_BN_CLICKED(IDC_DOA3, OnDoa3)
	ON_BN_CLICKED(IDC_DOA4, OnDoa4)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPCI1389S02DllTestDlg Nachrichten-Handler

BOOL CPCI1389S02DllTestDlg::OnInitDialog()
{
	struct _PCI1389S02_MODE Mode,TMode;
	CString String;
	struct _PCI1389S02_TO TOs;
	unsigned char x;
	UINT32 as;

	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Variablen und Controls initialisieren
	m_Z1n = 0;
	m_Z2n = 0;
	m_Z1Wert = 0;
	m_Z2Wert = 0;
	// Darstellung erneuern
	//UpdateDialog();
	// DLL/Treiber initialisieren
	//PCI1389S02_DeInitDriver();
	if (PCI1389S02_InitDriver() != 0)
	{
		int error;
		error = PCI1389S02_GetLastError(0);
		PCI1389S02_GetCardCount(&x);
		if (x != 0)
		{
			// Initialisierung erfolgreich
			m_Init = TRUE;
			// Zhler 1: Inkrementalzhler 1fach mit Triggerung auf
			//           Referenzzhler
			Mode.Cnt1_Mode = PCI1389S02_REFTRIG;
			// Zhler 2: Inkrementalzhler 1fach mit Triggerung auf
			//           Referenzzhler
			Mode.Cnt2_Mode = PCI1389S02_REFTRIG;
			// Referenzzhler: Als Timer
			Mode.Ref_Mode  = PCI1389S02_TIMER;
			// Referenztimer auf 20Hz (20KHz / 1000)
			Mode.Ref_Wert  = 1000;
			// IoMode
			Mode.Io_Mode = 0;
			// Betriebsarten setzen (Zhler und Fifo's werden
			// gelscht!)
			PCI1389S02_SetMode(0,&Mode);
			PCI1389S02_GetMode(0,&TMode);
			PCI1389S02_ReadMode(0,&as);
			// Timeouts setzen
			TOs.Cnt1 = 3000;
			TOs.Cnt2 = 2000;
			TOs.Ref  = 1000;
			TOs.Cnt1En = -1;
			TOs.Cnt2En = -1;
			TOs.RefEn  = -1;
			PCI1389S02_SetTimeOuts(0,&TOs);
			// Alle 3 Zhler starten
			PCI1389S02_StartCounter(0,PCI1389S02_CNT1 | PCI1389S02_CNT2 | PCI1389S02_REF);
			// Dialog ca. alle 100ms aktualisieren
			SetTimer(0,100,NULL);
			 UpdateDialog();
		}
		else
		{
			m_Init = FALSE;
			MessageBox("Fehler, keine PCI1389S02 gefunden!","Fehler",MB_ICONSTOP | MB_OK);
			exit(EXIT_FAILURE);
		}
	}
	else
	{
		PCI1389S02_DeInitDriver();
		m_Init = FALSE;
		MessageBox("Fehler beim Initialisieren der DLL!","Fehler",MB_ICONSTOP | MB_OK);
		exit(EXIT_FAILURE);
	}
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPCI1389S02DllTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPCI1389S02DllTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPCI1389S02DllTestDlg::OnTimer(UINT_PTR nIDEvent)//UINT nIDEvent) 
{
	UINT32 n;
	UINT32 x;
	union
		{
			INT32 (*T1)[8192];
			INT32 (*T2)[];
		}T;

	// Adresse wandeln
	T.T1 = &m_buffer;
	// Alle bisherigen Daten von Zhler 1 in einem
	// Block von maximal 8192 Werten holen
	PCI1389S02_GetCNT1Values(0,T.T2,8192,&n);
	// Gesamtanzahl der Werte von Zhler 1 um die
	// gelesene Anzahl erhhen
	// Hier knnte man die Daten blockweise ab-/umspeichern
	if (n > 0)
	{
		for (x=0;x<n;x++)
			if (m_buffer[x] != 512)
			{
				m_Z1n++;
				m_Z1Wert = m_buffer[n-1];
			}
	}
	// Alle bisherigen Daten von Zhler 1 in einem
	// Block von maximal 8192 Werten holen
	PCI1389S02_GetCNT2Values(0,T.T2,8192,&n);
	// Gesamtanzahl der Werte von Zhler 2 um die
	// gelesene Anzahl erhhen
	// Hier knnte man die Daten blockweise ab-/umspeichern
	if (n > 0)
	{
		m_Z2n += n;
		m_Z2Wert = m_buffer[n-1];
	}
	// Dialog erneuern
	UpdateDialog();
	
	CDialog::OnTimer(nIDEvent);
}

BOOL CPCI1389S02DllTestDlg::DestroyWindow() 
{
	// Wenn DLL/Treiber initialisiert wurden
	if (m_Init)
	{
		// Als erstes den Timer beenden
		KillTimer(1);
		// Alle 3 Zhler stoppen
		PCI1389S02_StopCounter(0,PCI1389S02_CNT1 | PCI1389S02_CNT2 | PCI1389S02_REF);
		// DLL/Treiber deinitialisieren
		PCI1389S02_DeInitDriver();
	}

	return CDialog::DestroyWindow();
}


void CPCI1389S02DllTestDlg::UpdateDialog()
{
	struct _PCI1389S02_STAT Status;
	CString String;
	unsigned char x;
	UINT32 y,z,a;

	// Neue Anzahl fr Zhler 1 darstellen
	String.Format("%ld",m_Z1n);
	m_Cnt1Count.SetWindowText(String);
	// Neuen Wert fr Zhler 1 darstellen
	String.Format("%ld",m_Z1Wert);
	m_Cnt1Value.SetWindowText(String);
	// Neue Anzahl fr Zhler 2 darstellen
	String.Format("%ld",m_Z2n);
	m_Cnt2Count.SetWindowText(String);
	// Neuen Wert fr Zhler 2 darstellen
	String.Format("%ld",m_Z2Wert);
	m_Cnt2Value.SetWindowText(String);
	// Status auslesen und Aufschlsseln
	x = PCI1389S02_GetStatus(0,&Status);
	x = PCI1389S02_ReadStatus(0,&y);
	x = PCI1389S02_ReadMode(0,&z);
	x = PCI1389S02_ReadIntEn(0,&a);
	if (x != 0)
	{
		// Statussignale fr Zhler 1 auswerten
		if ((Status.Cnt1 & PCI1389S02_CNTSTOP) != 0)
			m_Cnt1Stop.SetCheck(1);
		else
			m_Cnt1Stop.SetCheck(0);
		if ((Status.Cnt1 & PCI1389S02_CNTWAIT) != 0)
			m_Cnt1Wait.SetCheck(1);
		else
			m_Cnt1Wait.SetCheck(0);
		if ((Status.Cnt1 & PCI1389S02_CNTRUN) != 0)
			m_Cnt1Run.SetCheck(1);
		else
			m_Cnt1Run.SetCheck(0);
		if ((Status.Cnt1 & PCI1389S02_CNTFIFOOV) != 0)
			m_Cnt1OV.SetCheck(1);
		else
			m_Cnt1OV.SetCheck(0);
		if ((Status.Cnt1 & PCI1389S02_CNTINERR) != 0)
			m_Cnt1InErr.SetCheck(1);
		else
			m_Cnt1InErr.SetCheck(0);
		if ((Status.Cnt1 & PCI1389S02_CNTTIMEOUT) != 0)
			m_Cnt1TimeOut.SetCheck(1);
		else
			m_Cnt1TimeOut.SetCheck(0);
		// Statussignale fr Zhler 2 auswerten
		if ((Status.Cnt2 & PCI1389S02_CNTSTOP) != 0)
			m_Cnt2Stop.SetCheck(1);
		else
			m_Cnt2Stop.SetCheck(0);
		if ((Status.Cnt2 & PCI1389S02_CNTWAIT) != 0)
			m_Cnt2Wait.SetCheck(1);
		else
			m_Cnt2Wait.SetCheck(0);
		if ((Status.Cnt2 & PCI1389S02_CNTRUN) != 0)
			m_Cnt2Run.SetCheck(1);
		else
			m_Cnt2Run.SetCheck(0);
		if ((Status.Cnt2 & PCI1389S02_CNTFIFOOV) != 0)
			m_Cnt2OV.SetCheck(1);
		else
			m_Cnt2OV.SetCheck(0);
		if ((Status.Cnt2 & PCI1389S02_CNTINERR) != 0)
			m_Cnt2InErr.SetCheck(1);
		else
			m_Cnt2InErr.SetCheck(0);
		if ((Status.Cnt2 & PCI1389S02_CNTTIMEOUT) != 0)
			m_Cnt2TimeOut.SetCheck(1);
		else
			m_Cnt2TimeOut.SetCheck(0);
		// Statussignale fr Referenzzhler auswerten
		if ((Status.Ref & PCI1389S02_CNTSTOP) != 0)
			m_RefStop.SetCheck(1);
		else
			m_RefStop.SetCheck(0);
		if ((Status.Ref & PCI1389S02_CNTWAIT) != 0)
			m_RefWait.SetCheck(1);
		else
			m_RefWait.SetCheck(0);
		if ((Status.Ref & PCI1389S02_CNTRUN) != 0)
			m_RefRun.SetCheck(1);
		else
			m_RefRun.SetCheck(0);
		if ((Status.Ref & PCI1389S02_CNTINERR) != 0)
			m_RefInErr.SetCheck(1);
		else
			m_RefInErr.SetCheck(0);
		if ((Status.Ref & PCI1389S02_CNTTIMEOUT) != 0)
			m_RefTimeOut.SetCheck(1);
		else
			m_RefTimeOut.SetCheck(0);
	}
	// Digitale Eingnge auslesen und anzeigen
	PCI1389S02_GetPorts(0,&x);
	if ((x & 0x10) != 0)
		m_DinE1.SetCheck(1);
	else
		m_DinE1.SetCheck(0);
	if ((x & 0x20) != 0)
		m_DinE2.SetCheck(1);
	else
		m_DinE2.SetCheck(0);
	if ((x & 0x40) != 0)
		m_DinE3.SetCheck(1);
	else
		m_DinE3.SetCheck(0);
	if ((x & 0x80) != 0)
		m_DinE4.SetCheck(1);
	else
		m_DinE4.SetCheck(0);
	// Dialog erneuern
	UpdateData(FALSE);
}

void CPCI1389S02DllTestDlg::OnDoa1() 
{
	unsigned char Ports;

	// Status holen
	PCI1389S02_GetPorts(0,&Ports);
	// Digitale eingnge ausblenden
	Ports &= 0x0F;
	// Status Dialogelement holen
	if (m_DoutA1.GetCheck() == 1)
		// Portbit setzen
		Ports |= 0x01;
	else
		// Portbit lschen
		Ports &= 0x0E;
	// Neuen Portwert setzen
	PCI1389S02_SetPorts(0,Ports);
}

void CPCI1389S02DllTestDlg::OnDoa2() 
{
	unsigned char Ports;

	// Status holen
	PCI1389S02_GetPorts(0,&Ports);
	// Digitale eingnge ausblenden
	Ports &= 0x0F;
	// Status Dialogelement holen
	if (m_DoutA2.GetCheck() == 1)
		// Portbit setzen
		Ports |= 0x02;
	else
		// Portbit lschen
		Ports &= 0x0D;
	// Neuen Portwert setzen
	PCI1389S02_SetPorts(0,Ports);
}

void CPCI1389S02DllTestDlg::OnDoa3() 
{
	unsigned char Ports;

	// Status holen
	PCI1389S02_GetPorts(0,&Ports);
	// Digitale eingnge ausblenden
	Ports &= 0x0F;
	// Status Dialogelement holen
	if (m_DoutA3.GetCheck() == 1)
		// Portbit setzen
		Ports |= 0x04;
	else
		// Portbit lschen
		Ports &= 0x0B;
	// Neuen Portwert setzen
	PCI1389S02_SetPorts(0,Ports);
}

void CPCI1389S02DllTestDlg::OnDoa4() 
{
	unsigned char Ports;

	// Status holen
	PCI1389S02_GetPorts(0,&Ports);
	// Digitale eingnge ausblenden
	Ports &= 0x0F;
	// Status Dialogelement holen
	if (m_DoutA4.GetCheck() == 1)
		// Portbit setzen
		Ports |= 0x08;
	else
		// Portbit lschen
		Ports &= 0x07;
	// Neuen Portwert setzen
	PCI1389S02_SetPorts(0,Ports);
}


